#include "LinkedList.h"

Link::Link(unsigned int t, unsigned char n) {
    time = t;
    note[0] = 1;
    note[1] = n;
    next = NULL;
}

void Link::SetNext(Link* nx) {
    next = nx;
}

Link* Link::GetNext() {
    return next;
}

unsigned int Link::GetTime() {
    return time;
}

unsigned char * Link::GetNotes() {
    return note;
}

unsigned char Link::GetNum() {
    return note[0];
}

void Link::AddNote(unsigned char n) {
    if (note[0] == 8) return;
    for(char i=0; i<note[0]; i++) {
        if (note[i+1] == n) return;
    }
    note[0]++;
    note[note[0]] = n;
    return;
}

//--------------------------------------------------------

LinkedList::LinkedList() {
    first = NULL;
    itt = NULL;
}

LinkedList::~LinkedList() {
    clear();
}

void LinkedList::clear() {
    Link* temp;
    while (first != NULL)
    {
        temp = first->GetNext();
        delete first;
        first = temp;
    }
}

void LinkedList::ToFirst() {
    itt = first;
}

Link* LinkedList::GetLink() {
    return itt;
}

void LinkedList::NextLink() {
    itt = itt->GetNext();
}

bool LinkedList::isEmpty() {
    return first == NULL;
}

int LinkedList::size() {
    Link* temp = first;
    int count = 0;
    while (temp!=NULL) {
        temp = temp->GetNext();
        count++;
    }
    return count;
}

void LinkedList::AddLink(unsigned int t, unsigned char n) {
    Link* newlink;
    if (first == NULL) {
        newlink = new Link(t,n);
        first = newlink;
        itt = newlink;
        return;
    }
    if (t == itt->GetTime()) {
        itt->AddNote(n);
        return;
    }
    if (t < itt->GetTime() && (itt == first)) {
        first = new Link(t,n);
        first->SetNext(itt);
        return;
    }
    while (itt->GetNext() != NULL) {
        if (itt->GetNext()->GetTime() > t) {
            newlink = new Link(t,n);
            newlink->SetNext(itt->GetNext());
            itt->SetNext(newlink);
            itt = newlink;
            return;
        }
        itt = itt->GetNext();
        if (itt->GetTime() == t) {
            itt->AddNote(n);
            return;
        }
    }
    newlink = new Link(t,n);
    itt->SetNext(newlink);
    itt = newlink;
}
