#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) : QMainWindow(parent), ui(new Ui::MainWindow) {
    ui->setupUi(this);
    ui->statusBar->showMessage("Select \"Import...\" to import a midi file.");
}

MainWindow::~MainWindow() {
    delete ui;
}

void MainWindow::on_pushButton_2_clicked() {
    QString p = QFileDialog::getOpenFileName(this, "Select Midi File", path, "*.mid *.midi");
    if (p.isEmpty()) return;
    path = p;
    QString error = conv.open(path);
    if (!error.isEmpty()) {
        QMessageBox::warning(this, "Error", error);
        conv.closeFile();
        return;
    }
    error = conv.convert();
    if (!error.isEmpty()) {
        QMessageBox::warning(this, "Error", error);
        conv.closeFile();
        return;
    }
    ui->pushButton_3->setEnabled(true);
    if (!ui->pushButton->isEnabled() && !ui->pushButton->isEnabled()) {
        ui->pushButton->setEnabled(true);
        ui->pushButton_4->setEnabled(true);
    }
    ui->statusBar->showMessage(path);
}

void MainWindow::on_pushButton_clicked() {
    if (ui->pushButton->text() != "Stop") {
        conv.makeWav();
        wsound = new QSound("temp.wav");
        wsound->play();
        ui->pushButton_4->setDisabled(true);
        ui->pushButton->setText("Stop");
        ui->statusBar->showMessage("Playing...");
    } else {
        wsound->stop();
        delete wsound;
        ui->pushButton_4->setDisabled(false);
        ui->pushButton->setText("Preview");
        ui->statusBar->showMessage(path);
    }
}

void MainWindow::on_pushButton_3_clicked()
{
    QString p = QFileDialog::getSaveFileName(this, "Save File To", path2, "");
    if (p.isEmpty()) return;
    path2 = p;
    bool playr = ui->radioButton_3->isChecked();
    bool isProg = playr || ui->radioButton_2->isChecked();
    conv.output(path2, isProg, playr);
}

void MainWindow::on_pushButton_4_clicked()
{
    if (ui->pushButton_4->text() != "Stop") {
        mciSendString(QString("play "+path).utf16(),NULL,0,NULL);
        ui->pushButton->setDisabled(true);
        ui->pushButton_4->setText("Stop");
        ui->statusBar->showMessage("Playing...");
    } else {
        mciSendString(QString("stop "+path).utf16(),NULL,0,NULL);
        ui->pushButton->setDisabled(false);
        ui->pushButton_4->setText("Play Midi");
        ui->statusBar->showMessage(path);
    }
}

void MainWindow::on_horizontalSlider_2_valueChanged(int value)
{
    ui->label_2->setText("Freq Cutoff: "+QString::number(value));
    conv.fcuttoff = value;
}

void MainWindow::on_horizontalSlider_valueChanged(int value)
{
    ui->label->setText("Pitch Shift: "+QString::number(value));
    conv.pitchshift = value;
}

void MainWindow::on_horizontalSlider_2_sliderReleased()
{
    conv.convert();
}

void MainWindow::on_horizontalSlider_sliderReleased()
{
    conv.convert();
}
